Program
  Directory;


Uses
  Crt,Graph,Graph2,Menu;

{$i Konyvtar.Exp}
{$i Konyvtar.Rim}
{$i Menu.Inc}


Const
  OutFileNev = 'Out.Dat';

Function BeviteliMezo(X,Y:Word;Hossz:Byte):String;
  var
    AktX     : Word;
    Bill     : Char;
    Atmeneti : String;
    i        : Byte;
  begin
    AktX:=X;
    i:=0;

    Repeat
      i:=i+1;
      Repeat
        Bill:=ReadKey;
        If Bill=Chr(0) Then
          begin
            Bill:=ReadKey;{kiolvasom a 0 utanit is}
            Bill:='1';    {megvaltoztatom a Bill-t akarmire}
          end;
      Until Bill IN ['a'..'z','A'..'Z',' ','.',#13];
      If Bill<>#13 Then
        begin
          Atmeneti[i]:=Bill;
          Atmeneti[0]:=Chr(i);
          OutTextXY2(AktX,Y,Bill);
          AktX:=AktX+TextWidth(Bill);
        end{then};
    Until (Bill=#13{enter}) or (i=Hossz) or (i=255);
    BeviteliMezo:=Atmeneti;
    If Bill<>#13 Then Repeat Bill:=ReadKey; Until Bill=#13;
  end{BeviteliMezo};


Type
  THogyan = (olvas,ir);


Var
  MenuSiker      : Boolean;
  AktMenuPont    : Byte;
  KivalMenuPont  : Byte;
  Enter          : Boolean;
  Bill           : Char;
  Szov           : String;

  KonyvtarSzerk  : TKonyvtarSzerk;
  Elem           : TElemTipus;
  i              : Word;
  j              : Byte;


Function FajlNyit(var Fajl:Text;FajlNev:String;Hogyan:THogyan):Boolean;
  begin
    Assign(Fajl,FajlNev);
    {$i-}
      If Hogyan=olvas Then Reset(Fajl) Else Rewrite(Fajl);
    {$i+}
    If IOResult<>0 Then
      begin
        Sound(440); Delay(500); NoSound;
        FajlNyit:=False;
      end{then}
    Else
      FajlNyit:=True;
  end{FajlNyit};


Procedure FajlbolOlvas(FajlNev:String);
  var
    Sor  : String;
    Fajl : Text;
  begin
    If FajlNyit(Fajl,FajlNev,olvas){sikeres} Then
      begin
        While Not EoF(Fajl) do
          begin
            ReadLn(Fajl,Sor);
            If Sor='md' Then
              begin
                ReadLn(Fajl,Elem.Nev);
                Elem.Tipus:=Konyvtar;
                KonyvtarSzerk.MD(Elem);
              end{then};
            If Sor='cd' Then
              begin
                ReadLn(Fajl,Elem.Nev);
                Elem.Tipus:=Konyvtar;
                KonyvtarSzerk.CD(Elem);
              end{then};
            If Sor='cd__' Then
              begin
                KonyvtarSzerk.CD__;
              end{then};
            If Sor='rd' Then
              begin
                ReadLn(Fajl,Elem.Nev);
                Elem.Tipus:=Konyvtar;
                KonyvtarSzerk.RD(Elem);
              end{then};
            If Sor='del' Then
              begin
                ReadLn(Fajl,Elem.Nev);
                Elem.Tipus:=Konyv;
                KonyvtarSzerk.Del(Elem);
              end{then};
            If Sor='edit' Then
              begin
                ReadLn(Fajl,Elem.Nev);
                Elem.Tipus:=Konyv;
                KonyvtarSzerk.Edit(Elem);
              end{then};
          end{while};
        Close(Fajl);
      end{then}
  end{FajlbolOlvas};


Procedure FajlbaIr(FajlNev:String;Parancs:String;Elem:TElemTipus);
  var
    Fajl : Text;
  begin
    If FajlNyit(Fajl,FajlNev,ir){sikeres} Then
      begin
        Write(Fajl,Parancs);
        If Parancs<>'cd__' Then Write(Fajl,Elem.Nev);
        Close(Fajl);
      end{then}
  end{FajlbaIr};


Begin
KonyvtarSzerk.Format;{konyvtarszerkezet letrehozasa}

SetTextStyle(2,0,0);
MenuInit; {exportalva Menu.Inc-bol}

FoMenu.Be;
  AktMenuPont:=1; KivalMenuPont:=0;
  MenuSiker:=MenuSor.MenuRajz;
  Enter:=MenuSor.MenuReakcio(Bill,AktMenuPont);
  If Enter Then KivalMenuPont:=AktMenuPont;
FoMenu.Ki;


Repeat
  If KeyPressed Then
    begin
      Bill:=ReadKey;
      If Bill=chr(0) Then Bill:=ReadKey;
      Enter:=MenuSor.MenuReakcio(Bill,AktMenuPont);
      If Enter Then KivalMenuPont:=AktMenuPont;
    end{then};
  Case KivalMenuPont of
     1 : begin
           MDMenu.Elmentes;
           MDMenu.Rajz;
           MDMenu.Be;
             Szov:='Alknyvtr neve: ';
             OutTextXY2(4,4,Szov);
             Szov:=BeviteliMezo(4+TextWidth(Szov),4,((MDMenu.X2-MDMenu.X1) Div TextWidth('a')) - Length(Szov) - 1);
             Elem.Tipus:=Konyvtar;
             Elem.Nev:=Szov;
             KonyvtarSzerk.MD(Elem);
           MDMenu.Ki;
           MDMenu.Visszatoltes;
           FajlbaIr(OutFileNev,'md',Elem);
           KivalMenuPont:=7;
         end{1};
     2 : begin
           CDMenu.Elmentes;
           CDMenu.Rajz;
           CDMenu.Be;
             Szov:='Alknyvtr neve: ';
             OutTextXY2(4,4,Szov);
             Szov:=BeviteliMezo(4+TextWidth(Szov),4,((CDMenu.X2-CDMenu.X1) Div TextWidth('a')) - Length(Szov) - 1);
             Elem.Tipus:=Konyvtar;
             Elem.Nev:=Szov;
             KonyvtarSzerk.CD(Elem);
           CDMenu.Ki;
           CDMenu.Visszatoltes;
           FajlbaIr(OutFileNev,'cd',Elem);
           KivalMenuPont:=7;
         end{2};
     3 : begin
           KonyvtarSzerk.CD__;
           FajlbaIr(OutFileNev,'cd__',Elem);
           KivalMenuPont:=7;
         end{3};
     4 : begin
           RDMenu.Elmentes;
           RDMenu.Rajz;
           RDMenu.Be;
             Szov:='Alknyvtr neve: ';
             OutTextXY2(4,4,Szov);
             Szov:=BeviteliMezo(4+TextWidth(Szov),4,((RDMenu.X2-RDMenu.X1) Div TextWidth('a')) - Length(Szov) - 1);
             Elem.Tipus:=Konyvtar;
             Elem.Nev:=Szov;
             KonyvtarSzerk.RD(Elem);
           RDMenu.Ki;
           RDMenu.Visszatoltes;
           FajlbaIr(OutFileNev,'rd',Elem);
           KivalMenuPont:=7;
         end{4};
     5 : begin
           DelMenu.Elmentes;
           DelMenu.Rajz;
           DelMenu.Be;
             Szov:='Knyv neve: ';
             OutTextXY2(4,4,Szov);
             Szov:=BeviteliMezo(4+TextWidth(Szov),4,((DelMenu.X2-DelMenu.X1) Div TextWidth('a')) - Length(Szov) - 1);
             Elem.Tipus:=Konyv;
             Elem.Nev:=Szov;
             KonyvtarSzerk.Del(Elem);
           DelMenu.Ki;
           DelMenu.Visszatoltes;
           FajlbaIr(OutFileNev,'del',Elem);
           KivalMenuPont:=7;
         end{5};
     6 : begin
           EditMenu.Elmentes;
           EditMenu.Rajz;
           EditMenu.Be;
             Szov:='Knyv neve: ';
             OutTextXY2(4,4,Szov);
             Szov:=BeviteliMezo(4+TextWidth(Szov),4,((EditMenu.X2-EditMenu.X1) Div TextWidth('a')) - Length(Szov) - 1);
             Elem.Tipus:=Konyv;
             Elem.Nev:=Szov;
             KonyvtarSzerk.Edit(Elem);
           EditMenu.Ki;
           EditMenu.Visszatoltes;
           FajlbaIr(OutFileNev,'edit',Elem);
           KivalMenuPont:=7;
         end{6};
     7 : begin
           KonyvtarSzerk.FindFirst;
           i:=400;
           DirAblak.Be;
             DirAblak.ClrScr;
             While Not KonyvtarSzerk.Vegen_e do
               begin
                 KonyvtarSzerk.DirAktualis(Elem);
                 If Elem.Tipus=Konyvtar Then SetColor(LightGreen) Else SetColor(White);
                 OutTextXY2(5,i,Elem.Nev);
                 i:=i-(TextHeight(Elem.Nev)+4);
                 KonyvtarSzerk.FindNext;
               end{while};
             If Not KonyvtarSzerk.Ures_e Then
               begin
                 KonyvtarSzerk.DirAktualis(Elem);
                 If Elem.Tipus=Konyvtar Then SetColor(LightGreen) Else SetColor(White);
                 OutTextXY2(5,i,Elem.Nev);
               end{then}
             Else
               OutTextXY2(5,400,'Ures a konyvtar');
           DirAblak.Ki;
           KivalMenuPont:=0;
         end{7};
     8 : begin
           FajlMenu.Elmentes;
           FajlMenu.Rajz;
           FajlMenu.Be;
             Szov:='Fjl neve: ';
             OutTextXY2(4,4,Szov);
             Szov:=BeviteliMezo(4+TextWidth(Szov),4,((FajlMenu.X2-FajlMenu.X1) Div TextWidth('a')) - Length(Szov) - 1);
             FajlbolOlvas(Szov);
           FajlMenu.Ki;
           FajlMenu.Visszatoltes;
           KivalMenuPont:=7;
         end{8};
     9 : Bill:=#27;
  end{case};
Until Bill=#27;


DirAblak.Visszatoltes;
FoMenu.Visszatoltes;
SetTextStyle(0,0,0);

End.